# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-MooseX-Role-Parameterized
Summary:	Make your roles flexible through parameterization
Version:	1.11
Release:	12.%{__distinit}%{__distvers}
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/MooseX-Role-Parameterized
Source0:	https://cpan.metacpan.org/modules/by-module/MooseX/MooseX-Role-Parameterized-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Module::Runtime)
BuildRequires:	perl(Moose) >= 2.0300
BuildRequires:	perl(Moose::Exporter)
BuildRequires:	perl(Moose::Meta::Role)
BuildRequires:	perl(Moose::Role)
BuildRequires:	perl(Moose::Util)
BuildRequires:	perl(namespace::autoclean)
BuildRequires:	perl(namespace::clean) >= 0.19
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(CPAN::Meta::Check) >= 0.011
BuildRequires:	perl(CPAN::Meta::Requirements)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(lib)
BuildRequires:	perl(Module::Metadata)
BuildRequires:	perl(Moose::Util::TypeConstraints)
BuildRequires:	perl(overload)
BuildRequires:	perl(Storable)
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::Moose)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Test::Needs)
# Optional Test Dependencies
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(MooseX::Role::WithOverloading)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Moose) >= 2.0300

%description
Roles are composable units of behavior. They are useful for factoring out
functionality common to many classes from any part of your class hierarchy.
(See Moose::Cookbook::Roles::Recipe1 for an introduction to Moose::Role.)

While combining roles affords you a great deal of flexibility, individual
roles have very little in the way of configurability. Core Moose provides
alias for renaming methods to avoid conflicts, and excludes for ignoring
methods you don't want or need (see Moose::Cookbook::Roles::Recipe2 for more
about alias and excludes).

Because roles serve many different masters, they usually provide only the
least common denominator of functionality. To empower roles further, more
configurability than alias and excludes is required. Perhaps your role needs
to know which method to call when it is done. Or what default value to use for
its url attribute.

Parameterized roles offer exactly this solution.

%prep
%setup -q -n MooseX-Role-Parameterized-%{version}

%build
PERL_MM_FALLBACK_SILENCE_WARNING=1 perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes CONTRIBUTING README
%{perl_vendorlib}/MooseX/
%{_mandir}/man3/MooseX::Role::Parameterised.3*
%{_mandir}/man3/MooseX::Role::Parameterized.3*
%{_mandir}/man3/MooseX::Role::Parameterized::Extending.3*
%{_mandir}/man3/MooseX::Role::Parameterized::Meta::Role::Parameterized.3*
%{_mandir}/man3/MooseX::Role::Parameterized::Meta::Trait::Parameterizable.3*
%{_mandir}/man3/MooseX::Role::Parameterized::Meta::Trait::Parameterized.3*
%{_mandir}/man3/MooseX::Role::Parameterized::Parameters.3*
%{_mandir}/man3/MooseX::Role::Parameterized::Tutorial.3*

%changelog
* Mon May  1 2023 Paul Howarth <paul@city-fan.org> - 1.11-12
- Use SPDX-format license tag
- Use %%license unconditionally

* Tue Jul 16 2019 Paul Howarth <paul@city-fan.org> - 1.11-1
- Update to 1.11
  - Remove MooseX::Role::WithOverloading from test dependencies
    (CPAN RT#130075)
- Switch upstream from search.cpan.org to metacpan.org

* Thu Apr 26 2018 Paul Howarth <paul@city-fan.org> - 1.10-4
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Fri Jun 16 2017 Paul Howarth <paul@city-fan.org> - 1.10-2
- Perl 5.26 rebuild

* Fri Apr 21 2017 Paul Howarth <paul@city-fan.org> - 1.10-1
- Update to 1.10
  - Add MooseX::Role::Parameterised as stub documentation, for discoverability
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.96

* Sun Aug  7 2016 Paul Howarth <paul@city-fan.org> - 1.09-1
- Update to 1.09
  - Give 'anonymous' generated roles names that are similar to the original
    parameterized role so debug output is easier to read
- BR: perl-generators where available
- Simplify find command using -delete

* Mon Sep  8 2014 Paul Howarth <paul@city-fan.org> - 1.08-1
- Update to 1.08
   - Add x_breaks metadata for incompatibility issue with MooseX::Storage (now
     resolved with MooseX-Storage-0.47)
- Silence annoying toolchain message from Makefile.PL

* Thu Aug 14 2014 Paul Howarth <paul@city-fan.org> - 1.07-1
- Update to 1.07
  - Restored MooseX::Role::Parameterized->current_metaclass as a public
    method; apparently there is code on CPAN that relies on this
  - Remove README.pod from shipped dist
- This release by ETHER → update source URL
- Drop workarounds for problems in earlier releases

* Tue Aug  5 2014 Paul Howarth <paul@city-fan.org> - 1.05-2
- Remove installed README.pod and corresponding manpage, potentially
  conflicting (#1126416)
  https://github.com/Perl-Toolchain-Gang/ExtUtils-MakeMaker/issues/119

* Fri Aug  1 2014 Paul Howarth <paul@city-fan.org> - 1.05-1
- Update to 1.05
  - If a parameterizable role was reinitialized after any parameters or a role
    block was declared, those declarations were lost; reinitialization usually
    occurs when new metaroles are applied to the role by other MooseX modules
- This release by DROLSKY → update source URL
- Silence warnings about old toolchain since we really don't need
  Module::Build::Tiny

* Thu Jul 31 2014 Paul Howarth <paul@city-fan.org> - 1.04-1
- Update to 1.04
  - This extension is now implemented as a role metarole, which means it can
    (mostly) cooperate with other role extensions, such as
    MooseX::Role::WithOverloading; note that you should load
    MooseX::Role::Parameterized _after_ other extensions
  - This module no longer supports passing a "-metaclass" parameter when you
    load it; this was an artifact from a much earlier era of Moose extensions
  - Repository migrated to the github moose organization
  - Convert this distribution to Dist::Zilla to resolve packaging insanity
- This release by ETHER → update source URL
- Use %%license where possible
- Drop %%defattr, redundant since rpm 4.4
- Classify buildreqs by usage

* Sun Mar  9 2014 Paul Howarth <paul@city-fan.org> - 1.02-1
- Import from Fedora
- Update to 1.02

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.00-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Aug 02 2013 Petr Pisar <ppisar@redhat.com> - 1.00-7
- Perl 5.18 rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.00-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.00-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jun 22 2012 Petr Pisar <ppisar@redhat.com> - 1.00-4
- Perl 5.16 rebuild

* Sun Jan 22 2012 Iain Arnell <iarnell@gmail.com> - 1.00-3
- Drop tests subpackage; move tests to main package documentation

* Tue Jan 17 2012 Iain Arnell <iarnell@gmail.com> - 1.00-2
- Rebuilt again for F17 mass rebuild

* Sat Jan 14 2012 Iain Arnell <iarnell@gmail.com> - 1.00-1
- Update to latest upstream version

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.27-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sat Oct 01 2011 Iain Arnell <iarnell@gmail.com> - 0.27-1
- Update to latest upstream version

* Wed Jul 20 2011 Iain Arnell <iarnell@gmail.com> - 0.26-2
- Perl mass rebuild

* Sat May 14 2011 Iain Arnell <iarnell@gmail.com> - 0.26-1
- Update to latest upstream version

* Sun Mar 06 2011 Iain Arnell <iarnell@gmail.com> - 0.25-1
- Update to latest upstream version
- Clean up spec for modern rpmbuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.18-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Dec 21 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.18-3
- Rebuild to fix problems with vendorarch/lib (#661697)

* Thu May 13 2010 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.18-2
- perl-5.12.0 mass rebuild

* Sun Mar 14 2010 Chris Weyl <cweyl@alumni.drew.edu> - 0.18-1
- Update by Fedora::App::MaintainerTools 0.006
- Updating to latest GA CPAN version (0.18)

* Sun Feb 28 2010 Chris Weyl <cweyl@alumni.drew.edu> - 0.17-1
- Update by Fedora::App::MaintainerTools 0.004
- PERL_INSTALL_ROOT => DESTDIR

* Wed Jan 20 2010 Chris Weyl <cweyl@alumni.drew.edu> - 0.15-1
- Auto-update to 0.15 (by cpan-spec-update 0.01)
- Altered br on perl(Test::More) (0 => 0.88)

* Fri Dec  4 2009 Stepan Kasal <skasal@redhat.com> - 0.13-2
- Rebuild against perl 5.10.1

* Sat Sep 19 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.13-1
- Auto-update to 0.13 (by cpan-spec-update 0.01)
- Added a new br on perl(Test::Moose) (version 0)

* Wed Aug 19 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.10-1
- Auto-update to 0.10 (by cpan-spec-update 0.01)

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.09-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jun 16 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.09-2
- Drop README, LICENSE from doc

* Tue Jun 16 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.09-1
- Auto-update to 0.09 (by cpan-spec-update 0.01)
- Added a new br on perl(ExtUtils::MakeMaker) (version 6.42)
- Added a new req on perl(Moose) (version 0.78)

* Wed May 20 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.06-1
- Auto-update to 0.06 (by cpan-spec-update 0.01)
- Altered br on perl(Test::Exception) (0 => 0.27)
- Altered br on perl(Moose) (0.63 => 0.78)

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.04-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Feb 11 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.04-1
- Update to 0.04

* Sun Jan 25 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.03-1
- Update to 0.03

* Mon Jan 12 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.02-1
- Update for submission

* Sun Jan 11 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.02-0
- Initial RPM packaging
- Generated with cpan2dist (CPANPLUS::Dist::RPM version 0.0.7)
